> ## Documentation Index
> Fetch the complete documentation index at: https://docs.e6data.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Run profile

> run profile. GET /api/v1/workloads/{workload_id}/runs/{run_id}/profile. Uses the same payload, validation, revision checks and response as the unified HTTP API.

ReferenceApplies to: Unified engine deployments

## Related guidance

[Addresses and access](https://docs.e6data.com/transformation/http/access.md) · [Request identity](https://docs.e6data.com/transformation/http/request-identity.md) · [Errors and recovery](https://docs.e6data.com/transformation/http/errors.md) · [Pagination and results](https://docs.e6data.com/transformation/http/results.md)


## OpenAPI

````yaml openapi/transformation.json GET /api/v1/workloads/{workload_id}/runs/{run_id}/profile
openapi: 3.1.0
info:
  description: >-
    HTTP contracts for the Unified engine. Requests use the connected
    deployment's access model and configured owner. Response examples are
    illustrative; inspect your engine response in your client. SQL-managed
    secrets, credentials, streaming pipelines and maintenance run through
    session operations.
  title: Laminar Unified HTTP API
  version: v1
servers:
  - url: https://engine.example.com
    description: >-
      Example engine origin. Replace it with your deployment URL and any API
      mount prefix.
security: []
paths:
  /api/v1/workloads/{workload_id}/runs/{run_id}/profile:
    get:
      tags:
        - Workloads
      summary: run profile
      description: >-
        run profile. GET /api/v1/workloads/{workload_id}/runs/{run_id}/profile.
        Uses the same payload, validation, revision checks and response as the
        unified HTTP API.
      operationId: run_profile
      parameters:
        - in: path
          name: run_id
          required: true
          schema:
            format: uuid
            type: string
        - in: path
          name: workload_id
          required: true
          schema:
            format: uuid
            type: string
        - in: query
          name: download
          required: false
          schema:
            type: boolean
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/kernel_controller_src_profiling_model_rs_RunProfileReport
          description: Successful response.
        default:
          content:
            application/json:
              example:
                error:
                  code: invalid_request
                  message: Check the request fields
              schema:
                $ref: '#/components/schemas/ApiError'
          description: A rejected or failed request. Inspect error.code before retrying.
components:
  schemas:
    kernel_controller_src_profiling_model_rs_RunProfileReport:
      properties:
        controller:
          anyOf:
            - $ref: >-
                #/components/schemas/shared_common_src_profiling_rs_ExecutionProfile
            - type: 'null'
        critical_path:
          items:
            $ref: '#/components/schemas/shared_common_src_lib_rs_TaskRunId'
          type: array
        details_sampled:
          type: boolean
        enabled:
          type: boolean
        evidence:
          anyOf:
            - $ref: >-
                #/components/schemas/shared_common_src_profiling_rs_RunProfileEvidence
            - type: 'null'
        identity:
          $ref: >-
            #/components/schemas/kernel_controller_src_profiling_model_rs_ProfileIdentity
        missing:
          items:
            type: string
          type: array
        run:
          $ref: >-
            #/components/schemas/kernel_controller_src_runs_model_rs_WorkloadRunStatusResponse
        state:
          type: string
        tasks:
          items:
            $ref: >-
              #/components/schemas/kernel_controller_src_profiling_model_rs_TaskProfile
          type: array
        timings:
          $ref: >-
            #/components/schemas/kernel_controller_src_profiling_model_rs_ProfileTimings
        truncated:
          type: boolean
        version:
          minimum: 0
          type: integer
      required:
        - identity
        - evidence
        - timings
        - details_sampled
        - version
        - enabled
        - state
        - run
        - controller
        - tasks
        - critical_path
        - missing
        - truncated
      type: object
    ApiError:
      properties:
        error:
          properties:
            code:
              type: string
            message:
              type: string
          required:
            - code
            - message
          type: object
      required:
        - error
      type: object
    shared_common_src_profiling_rs_ExecutionProfile:
      properties:
        architecture:
          type: string
        build_revision:
          anyOf:
            - type: string
            - type: 'null'
        compute:
          anyOf:
            - $ref: >-
                #/components/schemas/shared_common_src_lib_rs_ComputeRequirements
            - type: 'null'
        details_sampled:
          type: boolean
        elapsed_nanos:
          minimum: 0
          type: integer
        engine_version:
          anyOf:
            - type: string
            - type: 'null'
        inputs:
          items:
            $ref: '#/components/schemas/shared_common_src_profiling_rs_ProfileBinding'
          type: array
        metrics:
          items:
            $ref: '#/components/schemas/shared_common_src_profiling_rs_ProfileMetric'
          type: array
        missing:
          items:
            type: string
          type: array
        native:
          anyOf:
            - $ref: >-
                #/components/schemas/shared_common_src_query_profile_rs_QueryProfile
            - type: 'null'
        operating_system:
          type: string
        outputs:
          items:
            $ref: '#/components/schemas/shared_common_src_profiling_rs_ProfileBinding'
          type: array
        process_instance:
          type: string
        program_sha256:
          anyOf:
            - type: string
            - type: 'null'
        resource_summary:
          anyOf:
            - $ref: >-
                #/components/schemas/shared_common_src_profiling_rs_ResourceSummary
            - type: 'null'
        resources:
          items:
            $ref: '#/components/schemas/shared_common_src_profiling_rs_ResourceSample'
          type: array
        role:
          type: string
        stage_events:
          minimum: 0
          type: integer
        stage_summaries:
          items:
            $ref: '#/components/schemas/shared_common_src_profiling_rs_StageSummary'
          type: array
        stages:
          items:
            $ref: '#/components/schemas/shared_common_src_profiling_rs_ProfileStage'
          type: array
        started_monotonic_nanos:
          minimum: 0
          type: integer
        started_unix_nanos:
          minimum: 0
          type: integer
        task_attempt_id:
          anyOf:
            - $ref: '#/components/schemas/shared_common_src_lib_rs_TaskAttemptId'
            - type: 'null'
        task_run_id:
          anyOf:
            - $ref: '#/components/schemas/shared_common_src_lib_rs_TaskRunId'
            - type: 'null'
        truncated:
          type: boolean
        version:
          minimum: 0
          type: integer
      required:
        - version
        - role
        - process_instance
        - architecture
        - operating_system
        - engine_version
        - build_revision
        - inputs
        - outputs
        - task_run_id
        - task_attempt_id
        - started_unix_nanos
        - started_monotonic_nanos
        - elapsed_nanos
        - program_sha256
        - compute
        - native
        - metrics
        - stages
        - stage_summaries
        - stage_events
        - resources
        - resource_summary
        - details_sampled
        - truncated
        - missing
      type: object
    shared_common_src_lib_rs_TaskRunId:
      format: uuid
      type: string
    shared_common_src_profiling_rs_RunProfileEvidence:
      properties:
        baselines:
          items:
            $ref: >-
              #/components/schemas/shared_common_src_profiling_rs_ProfileBaseline
          type: array
        cache_policy:
          anyOf:
            - type: string
            - type: 'null'
        case_identity:
          anyOf:
            - type: string
            - type: 'null'
        checks:
          items:
            $ref: '#/components/schemas/shared_common_src_profiling_rs_ProfileCheck'
          type: array
        dataset_identity:
          anyOf:
            - type: string
            - type: 'null'
        labels:
          additionalProperties:
            type: string
          type: object
        task_identities:
          additionalProperties:
            type: string
          type: object
        version:
          minimum: 0
          type: integer
      required:
        - version
        - dataset_identity
        - case_identity
        - cache_policy
        - labels
        - task_identities
        - checks
        - baselines
      type: object
    kernel_controller_src_profiling_model_rs_ProfileIdentity:
      properties:
        case_sha256:
          type: string
        compute_sha256:
          type: string
        input_sha256:
          type: string
        profiling:
          type: boolean
      required:
        - case_sha256
        - input_sha256
        - compute_sha256
        - profiling
      type: object
    kernel_controller_src_runs_model_rs_WorkloadRunStatusResponse:
      properties:
        admission_rejection:
          anyOf:
            - type: string
            - type: 'null'
        created_at:
          anyOf:
            - $ref: >-
                #/components/schemas/shared_common_src_time_rs_WallClockTimestamp
            - type: 'null'
        finished_at:
          anyOf:
            - $ref: >-
                #/components/schemas/shared_common_src_time_rs_WallClockTimestamp
            - type: 'null'
        invocation:
          anyOf:
            - $ref: >-
                #/components/schemas/shared_common_src_parameters_rs_RunInvocation
            - type: 'null'
        occurrence_id:
          $ref: '#/components/schemas/shared_common_src_lib_rs_OccurrenceId'
        profiling_available:
          type: boolean
        started_at:
          anyOf:
            - $ref: >-
                #/components/schemas/shared_common_src_time_rs_WallClockTimestamp
            - type: 'null'
        status:
          $ref: >-
            #/components/schemas/kernel_controller_src_runs_model_rs_WorkloadRunStatus
        tasks:
          items:
            $ref: >-
              #/components/schemas/kernel_controller_src_attempts_model_rs_TaskStatusResponse
          type: array
        workload_id:
          $ref: '#/components/schemas/shared_common_src_lib_rs_WorkloadId'
        workload_run_id:
          $ref: '#/components/schemas/shared_common_src_lib_rs_WorkloadRunId'
      required:
        - profiling_available
        - admission_rejection
        - created_at
        - started_at
        - finished_at
        - workload_id
        - workload_run_id
        - occurrence_id
        - status
        - tasks
      type: object
    kernel_controller_src_profiling_model_rs_TaskProfile:
      properties:
        attempts:
          items:
            $ref: >-
              #/components/schemas/kernel_controller_src_profiling_model_rs_AttemptProfile
          type: array
        name:
          type: string
        task_run_id:
          $ref: '#/components/schemas/shared_common_src_lib_rs_TaskRunId'
      required:
        - task_run_id
        - name
        - attempts
      type: object
    kernel_controller_src_profiling_model_rs_ProfileTimings:
      properties:
        controller_profile_storage_nanos:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
        tasks:
          items:
            $ref: >-
              #/components/schemas/kernel_controller_src_profiling_model_rs_TaskTimings
          type: array
        wall_nanos:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
      required:
        - wall_nanos
        - controller_profile_storage_nanos
        - tasks
      type: object
    shared_common_src_lib_rs_ComputeRequirements:
      properties:
        cpu_millicores:
          minimum: 1
          type: integer
        memory_bytes:
          minimum: 1
          type: integer
        tuning:
          anyOf:
            - $ref: '#/components/schemas/shared_common_src_compute_rs_ComputeTuning'
            - type: 'null'
      required:
        - cpu_millicores
        - memory_bytes
      type: object
    shared_common_src_profiling_rs_ProfileBinding:
      properties:
        accepted_filters:
          minimum: 0
          type: integer
        binding_id:
          type: string
        boundary_sha256:
          anyOf:
            - type: string
            - type: 'null'
        connector:
          type: string
        data_version:
          anyOf:
            - $ref: '#/components/schemas/shared_common_src_lib_rs_TableDataVersion'
            - type: 'null'
        projected_columns:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
        resource_identity_sha256:
          type: string
        table:
          anyOf:
            - $ref: '#/components/schemas/shared_common_src_lib_rs_TableReference'
            - type: 'null'
      required:
        - binding_id
        - connector
        - resource_identity_sha256
        - boundary_sha256
        - table
        - data_version
        - projected_columns
        - accepted_filters
      type: object
    shared_common_src_profiling_rs_ProfileMetric:
      properties:
        attributes:
          additionalProperties:
            type: string
          type: object
        kind:
          type: string
        last:
          type: number
        max:
          type: number
        min:
          type: number
        name:
          type: string
        observations:
          minimum: 0
          type: integer
        sum:
          type: number
        unit:
          type: string
      required:
        - name
        - unit
        - kind
        - attributes
        - observations
        - sum
        - min
        - max
        - last
      type: object
    shared_common_src_query_profile_rs_QueryProfile:
      properties:
        engine:
          type: string
        metrics:
          additionalProperties:
            type: number
          type: object
        operators:
          items:
            $ref: >-
              #/components/schemas/shared_common_src_query_profile_rs_QueryPlanOperator
          type: array
        truncated:
          type: boolean
      required:
        - engine
        - metrics
        - operators
        - truncated
      type: object
    shared_common_src_profiling_rs_ResourceSummary:
      properties:
        container_memory_limit_bytes:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
        container_memory_peak_bytes:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
        covered_nanos:
          minimum: 0
          type: integer
        cpu_average_cores:
          anyOf:
            - type: number
            - type: 'null'
        cpu_core_seconds:
          anyOf:
            - type: number
            - type: 'null'
        cpu_peak_cores:
          anyOf:
            - type: number
            - type: 'null'
        first:
          anyOf:
            - $ref: >-
                #/components/schemas/shared_common_src_profiling_rs_ResourceSample
            - type: 'null'
        last:
          anyOf:
            - $ref: >-
                #/components/schemas/shared_common_src_profiling_rs_ResourceSample
            - type: 'null'
        oom_events:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
        read_bytes:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
        rss_average_bytes:
          anyOf:
            - type: number
            - type: 'null'
        rss_peak_bytes:
          minimum: 0
          type: integer
        samples:
          minimum: 0
          type: integer
        throttled_seconds:
          anyOf:
            - type: number
            - type: 'null'
        written_bytes:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
      required:
        - samples
        - covered_nanos
        - cpu_core_seconds
        - cpu_average_cores
        - cpu_peak_cores
        - rss_average_bytes
        - rss_peak_bytes
        - container_memory_peak_bytes
        - container_memory_limit_bytes
        - read_bytes
        - written_bytes
        - throttled_seconds
        - oom_events
        - first
        - last
      type: object
    shared_common_src_profiling_rs_ResourceSample:
      properties:
        container_cpu_seconds:
          anyOf:
            - type: number
            - type: 'null'
        container_memory_bytes:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
        container_memory_limit_bytes:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
        offset_nanos:
          minimum: 0
          type: integer
        oom_events:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
        process_cpu_seconds:
          type: number
        read_bytes:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
        rss_bytes:
          minimum: 0
          type: integer
        throttled_seconds:
          anyOf:
            - type: number
            - type: 'null'
        written_bytes:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
      required:
        - offset_nanos
        - process_cpu_seconds
        - rss_bytes
        - read_bytes
        - written_bytes
        - container_memory_bytes
        - container_memory_limit_bytes
        - container_cpu_seconds
        - throttled_seconds
        - oom_events
      type: object
    shared_common_src_profiling_rs_StageSummary:
      properties:
        count:
          minimum: 0
          type: integer
        max_nanos:
          minimum: 0
          type: integer
        min_nanos:
          minimum: 0
          type: integer
        name:
          type: string
        outcome:
          type: string
        total_nanos:
          minimum: 0
          type: integer
      required:
        - name
        - outcome
        - count
        - total_nanos
        - min_nanos
        - max_nanos
      type: object
    shared_common_src_profiling_rs_ProfileStage:
      properties:
        duration_nanos:
          minimum: 0
          type: integer
        name:
          type: string
        offset_nanos:
          minimum: 0
          type: integer
        outcome:
          type: string
      required:
        - name
        - offset_nanos
        - duration_nanos
        - outcome
      type: object
    shared_common_src_lib_rs_TaskAttemptId:
      format: uuid
      type: string
    shared_common_src_profiling_rs_ProfileBaseline:
      properties:
        case_identity:
          type: string
        cpu_millicores:
          minimum: 0
          type: integer
        dataset_identity:
          type: string
        execution_nanos:
          minimum: 0
          type: integer
        image:
          anyOf:
            - type: string
            - type: 'null'
        memory_bytes:
          minimum: 0
          type: integer
        name:
          type: string
        profiling:
          type: boolean
        task_name:
          anyOf:
            - type: string
            - type: 'null'
        timing:
          $ref: >-
            #/components/schemas/shared_common_src_profiling_rs_ProfileTimingMetric
        version:
          anyOf:
            - type: string
            - type: 'null'
      required:
        - name
        - task_name
        - dataset_identity
        - case_identity
        - cpu_millicores
        - memory_bytes
        - profiling
        - execution_nanos
        - timing
        - image
        - version
      type: object
    shared_common_src_profiling_rs_ProfileCheck:
      properties:
        actual:
          anyOf:
            - type: string
            - type: 'null'
        expected:
          anyOf:
            - type: string
            - type: 'null'
        name:
          type: string
        passed:
          type: boolean
      required:
        - name
        - passed
        - expected
        - actual
      type: object
    shared_common_src_time_rs_WallClockTimestamp:
      properties:
        unix_millis:
          type: integer
      required:
        - unix_millis
      type: object
    shared_common_src_parameters_rs_RunInvocation:
      properties:
        effective_parameters:
          $ref: '#/components/schemas/shared_common_src_parameters_rs_ParameterValues'
        scheduled_at_unix_millis:
          type: integer
        supplied_parameters:
          $ref: '#/components/schemas/shared_common_src_parameters_rs_ParameterValues'
        trigger:
          $ref: '#/components/schemas/shared_common_src_parameters_rs_RunTrigger'
        workflow:
          $ref: '#/components/schemas/shared_common_src_workflow_rs_RunContext'
        workload_revision:
          minimum: 0
          type: integer
      required:
        - workload_revision
        - supplied_parameters
        - effective_parameters
        - scheduled_at_unix_millis
        - trigger
      type: object
    shared_common_src_lib_rs_OccurrenceId:
      format: uuid
      type: string
    kernel_controller_src_runs_model_rs_WorkloadRunStatus:
      oneOf:
        - const: Cancelling
          type: string
        - const: Cancelled
          type: string
        - const: Pending
          type: string
        - const: Skipped
          type: string
        - const: Running
          type: string
        - const: Succeeded
          type: string
        - const: Failed
          type: string
        - const: OutcomeUnknown
          type: string
    kernel_controller_src_attempts_model_rs_TaskStatusResponse:
      properties:
        active_attempt_id:
          anyOf:
            - $ref: '#/components/schemas/shared_common_src_lib_rs_TaskAttemptId'
            - type: 'null'
        cleanup_complete:
          type: boolean
        created_at:
          anyOf:
            - $ref: >-
                #/components/schemas/shared_common_src_time_rs_WallClockTimestamp
            - type: 'null'
        execution:
          anyOf:
            - $ref: >-
                #/components/schemas/shared_common_src_execution_mod_rs_ResolvedExecution
            - type: 'null'
        failure:
          anyOf:
            - type: string
            - type: 'null'
        finished_at:
          anyOf:
            - $ref: >-
                #/components/schemas/shared_common_src_time_rs_WallClockTimestamp
            - type: 'null'
        incremental:
          anyOf:
            - $ref: >-
                #/components/schemas/kernel_controller_src_attempts_model_rs_IncrementalTaskProgress
            - type: 'null'
          description: >-
            Saved source boundaries, without connector access or catalog
            payloads.
        name:
          type: string
        phase_history:
          items:
            $ref: >-
              #/components/schemas/kernel_controller_src_attempts_model_rs_TaskStatusPhase
          type: array
        phase_history_complete:
          type: boolean
        profiling_available:
          type: boolean
        queue:
          anyOf:
            - $ref: >-
                #/components/schemas/kernel_controller_src_queue_model_rs_QueuedAttempt
            - type: 'null'
        started_at:
          anyOf:
            - $ref: >-
                #/components/schemas/shared_common_src_time_rs_WallClockTimestamp
            - type: 'null'
        status:
          $ref: >-
            #/components/schemas/kernel_controller_src_attempts_model_rs_TaskRunStatus
        task_run_id:
          $ref: '#/components/schemas/shared_common_src_lib_rs_TaskRunId'
        workflow:
          $ref: >-
            #/components/schemas/kernel_controller_src_workflow_mod_rs_TaskWorkflowState
        workload_id:
          $ref: '#/components/schemas/shared_common_src_lib_rs_WorkloadId'
        workload_run_id:
          $ref: '#/components/schemas/shared_common_src_lib_rs_WorkloadRunId'
        write_summary:
          anyOf:
            - $ref: '#/components/schemas/shared_common_src_lib_rs_TaskWriteSummary'
            - type: 'null'
          description: Present only when Controller has durably confirmed commit.
      required:
        - profiling_available
        - workflow
        - queue
        - cleanup_complete
        - created_at
        - started_at
        - finished_at
        - phase_history
        - phase_history_complete
        - workload_id
        - task_run_id
        - workload_run_id
        - name
        - status
        - active_attempt_id
        - failure
        - write_summary
      type: object
    shared_common_src_lib_rs_WorkloadId:
      format: uuid
      type: string
    shared_common_src_lib_rs_WorkloadRunId:
      format: uuid
      type: string
    kernel_controller_src_profiling_model_rs_AttemptProfile:
      properties:
        allocation_id:
          anyOf:
            - $ref: '#/components/schemas/shared_common_src_lib_rs_AllocationId'
            - type: 'null'
        missing:
          items:
            type: string
          type: array
        number:
          minimum: 0
          type: integer
        pipeline:
          $ref: >-
            #/components/schemas/kernel_controller_src_profiling_model_rs_PipelineSummary
        profile:
          anyOf:
            - $ref: >-
                #/components/schemas/shared_common_src_profiling_rs_ExecutionProfile
            - type: 'null'
        profile_storage_nanos:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
        status:
          $ref: >-
            #/components/schemas/kernel_controller_src_attempts_model_rs_TaskRunStatus
        task_attempt_id:
          $ref: '#/components/schemas/shared_common_src_lib_rs_TaskAttemptId'
        worker_id:
          anyOf:
            - $ref: '#/components/schemas/shared_common_src_lib_rs_WorkerId'
            - type: 'null'
      required:
        - profile_storage_nanos
        - pipeline
        - task_attempt_id
        - number
        - status
        - allocation_id
        - worker_id
        - profile
        - missing
      type: object
    kernel_controller_src_profiling_model_rs_TaskTimings:
      properties:
        executor_nanos:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
        native_sql_nanos:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
        phase_history_complete:
          type: boolean
        phases:
          items:
            $ref: >-
              #/components/schemas/kernel_controller_src_profiling_model_rs_PhaseTiming
          type: array
        profile_storage_nanos:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
        running_outside_executor_nanos:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
        task_run_id:
          $ref: '#/components/schemas/shared_common_src_lib_rs_TaskRunId'
        wall_nanos:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
      required:
        - task_run_id
        - wall_nanos
        - phase_history_complete
        - phases
        - executor_nanos
        - profile_storage_nanos
        - running_outside_executor_nanos
        - native_sql_nanos
      type: object
    shared_common_src_compute_rs_ComputeTuning:
      properties:
        batch_rows:
          anyOf:
            - minimum: 1
              type: integer
            - type: 'null'
        file_read_concurrency:
          anyOf:
            - minimum: 1
              type: integer
            - type: 'null'
        input_prefetch_batches:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
        native_parquet_scan:
          anyOf:
            - type: boolean
            - type: 'null'
          description: >-
            False always uses connector-produced Arrow batches. Omitted keeps
            the native Parquet capability enabled when the source can supply it
            safely.
        output_buffer_batches:
          anyOf:
            - minimum: 1
              type: integer
            - type: 'null'
        query_memory_bytes:
          anyOf:
            - minimum: 1
              type: integer
            - type: 'null'
        spill_bytes:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
          description: >-
            Zero disables disk spill. The directory is controlled by the
            deployment.
        threads:
          anyOf:
            - minimum: 1
              type: integer
            - type: 'null'
        write_batch_rows:
          anyOf:
            - minimum: 1
              type: integer
            - type: 'null'
        write_parallelism:
          anyOf:
            - minimum: 1
              type: integer
            - type: 'null'
      required:
        - threads
        - query_memory_bytes
        - batch_rows
        - write_batch_rows
        - write_parallelism
        - spill_bytes
        - output_buffer_batches
        - file_read_concurrency
        - input_prefetch_batches
      type: object
    shared_common_src_lib_rs_TableDataVersion:
      oneOf:
        - properties:
            Version:
              type: string
          required:
            - Version
          type: object
        - const: Empty
          type: string
        - const: Unversioned
          type: string
    shared_common_src_lib_rs_TableReference:
      properties:
        catalog_id:
          $ref: '#/components/schemas/shared_common_src_lib_rs_CatalogId'
        name:
          type: string
        namespace:
          items:
            type: string
          type: array
      required:
        - catalog_id
        - namespace
        - name
      type: object
    shared_common_src_query_profile_rs_QueryPlanOperator:
      properties:
        children:
          items:
            $ref: >-
              #/components/schemas/shared_common_src_query_profile_rs_QueryPlanOperator
          type: array
        metrics:
          additionalProperties:
            type: number
          type: object
        name:
          type: string
      required:
        - name
        - metrics
        - children
      type: object
    shared_common_src_profiling_rs_ProfileTimingMetric:
      oneOf:
        - const: task_execution
          type: string
        - const: native_sql
          type: string
        - const: wall
          type: string
    shared_common_src_parameters_rs_ParameterValues:
      additionalProperties:
        description: JSON value; fields depend on the enclosing document or provider.
      type: object
    shared_common_src_parameters_rs_RunTrigger:
      oneOf:
        - const: manual
          type: string
        - const: scheduled
          type: string
    shared_common_src_workflow_rs_RunContext:
      properties:
        backfill_id:
          anyOf:
            - format: uuid
              type: string
            - type: 'null'
        data_window:
          anyOf:
            - $ref: '#/components/schemas/shared_common_src_workflow_rs_DataWindow'
            - type: 'null'
        rerun:
          anyOf:
            - $ref: '#/components/schemas/shared_common_src_workflow_rs_RerunOrigin'
            - type: 'null'
      required:
        - data_window
        - rerun
        - backfill_id
      type: object
    shared_common_src_execution_mod_rs_ResolvedExecution:
      properties:
        compute_requirements:
          $ref: '#/components/schemas/shared_common_src_lib_rs_ComputeRequirements'
        deployment_profile:
          anyOf:
            - type: string
            - type: 'null'
        profile:
          anyOf:
            - type: string
            - type: 'null'
        provisioner:
          type: string
        provisioner_fingerprint:
          type: string
        worker_scope:
          anyOf:
            - $ref: '#/components/schemas/shared_common_src_lib_rs_WorkerScope'
            - type: 'null'
          description: Older records inherit the scope stored on their workload run.
      required:
        - provisioner
        - provisioner_fingerprint
        - profile
        - compute_requirements
      type: object
    kernel_controller_src_attempts_model_rs_IncrementalTaskProgress:
      properties:
        commit_id:
          $ref: '#/components/schemas/shared_common_src_lib_rs_CommitId'
        end:
          anyOf:
            - $ref: '#/components/schemas/shared_common_src_lib_rs_TableDataVersion'
            - type: 'null'
        start:
          anyOf:
            - $ref: '#/components/schemas/shared_common_src_lib_rs_TableDataVersion'
            - type: 'null'
        table_identity:
          anyOf:
            - type: string
            - type: 'null'
      required:
        - table_identity
        - start
        - end
        - commit_id
      type: object
    kernel_controller_src_attempts_model_rs_TaskStatusPhase:
      properties:
        attempt_number:
          anyOf:
            - minimum: 1
              type: integer
            - type: 'null'
        finished_at:
          anyOf:
            - $ref: >-
                #/components/schemas/shared_common_src_time_rs_WallClockTimestamp
            - type: 'null'
        started_at:
          $ref: '#/components/schemas/shared_common_src_time_rs_WallClockTimestamp'
        status:
          $ref: >-
            #/components/schemas/kernel_controller_src_attempts_model_rs_TaskRunStatus
        task_attempt_id:
          anyOf:
            - $ref: '#/components/schemas/shared_common_src_lib_rs_TaskAttemptId'
            - type: 'null'
      required:
        - status
        - started_at
        - finished_at
        - task_attempt_id
        - attempt_number
      type: object
    kernel_controller_src_queue_model_rs_QueuedAttempt:
      properties:
        deadline:
          anyOf:
            - $ref: >-
                #/components/schemas/shared_common_src_time_rs_WallClockTimestamp
            - type: 'null'
        entered_at:
          $ref: '#/components/schemas/shared_common_src_time_rs_WallClockTimestamp'
        reason:
          type: string
        task_attempt_id:
          $ref: '#/components/schemas/shared_common_src_lib_rs_TaskAttemptId'
      required:
        - task_attempt_id
        - entered_at
        - deadline
        - reason
      type: object
    kernel_controller_src_attempts_model_rs_TaskRunStatus:
      oneOf:
        - const: Cancelling
          type: string
        - const: Cancelled
          type: string
        - const: Pending
          type: string
        - const: Planning
          type: string
        - const: Queued
          type: string
        - const: Provisioning
          type: string
        - const: WaitingWorker
          type: string
        - const: Running
          type: string
        - const: Committing
          type: string
        - const: WaitingRetry
          type: string
        - const: Succeeded
          type: string
        - const: Failed
          type: string
        - const: Skipped
          type: string
        - const: OutcomeUnknown
          type: string
    kernel_controller_src_workflow_mod_rs_TaskWorkflowState:
      properties:
        reused_from:
          anyOf:
            - $ref: '#/components/schemas/shared_common_src_lib_rs_WorkloadRunId'
            - type: 'null'
        wait:
          anyOf:
            - $ref: '#/components/schemas/kernel_sensors_src_lib_rs_WaitState'
            - type: 'null'
      required: []
      type: object
    shared_common_src_lib_rs_TaskWriteSummary:
      properties:
        affected_rows:
          minimum: 0
          type: integer
        receipt:
          $ref: '#/components/schemas/shared_common_src_lib_rs_CommitReceipt'
      required:
        - affected_rows
        - receipt
      type: object
    shared_common_src_lib_rs_AllocationId:
      format: uuid
      type: string
    kernel_controller_src_profiling_model_rs_PipelineSummary:
      properties:
        decode_nanos:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
        decode_queue_nanos:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
        encode_upload_nanos:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
        first_batch_nanos:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
        flush_nanos:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
        input_arrow_bytes:
          anyOf:
            - type: number
            - type: 'null'
        input_rows:
          anyOf:
            - type: number
            - type: 'null'
        input_wait_nanos:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
        native_peak_memory_bytes:
          anyOf:
            - type: number
            - type: 'null'
        native_peak_spill_bytes:
          anyOf:
            - type: number
            - type: 'null'
        output_arrow_bytes:
          anyOf:
            - type: number
            - type: 'null'
        output_file_bytes:
          anyOf:
            - type: number
            - type: 'null'
        output_file_max_bytes:
          anyOf:
            - type: number
            - type: 'null'
        output_file_min_bytes:
          anyOf:
            - type: number
            - type: 'null'
        output_files:
          anyOf:
            - type: number
            - type: 'null'
        output_rows:
          anyOf:
            - type: number
            - type: 'null'
        output_wait_nanos:
          anyOf:
            - minimum: 0
              type: integer
            - type: 'null'
        rows_per_second:
          anyOf:
            - type: number
            - type: 'null'
        storage_read_bytes:
          anyOf:
            - type: number
            - type: 'null'
        storage_read_bytes_per_second:
          anyOf:
            - type: number
            - type: 'null'
        storage_written_bytes:
          anyOf:
            - type: number
            - type: 'null'
      required:
        - input_rows
        - input_arrow_bytes
        - output_rows
        - output_arrow_bytes
        - storage_read_bytes
        - storage_written_bytes
        - output_files
        - output_file_bytes
        - output_file_min_bytes
        - output_file_max_bytes
        - rows_per_second
        - storage_read_bytes_per_second
        - input_wait_nanos
        - output_wait_nanos
        - first_batch_nanos
        - decode_nanos
        - decode_queue_nanos
        - encode_upload_nanos
        - flush_nanos
        - native_peak_memory_bytes
        - native_peak_spill_bytes
      type: object
    shared_common_src_lib_rs_WorkerId:
      format: uuid
      type: string
    kernel_controller_src_profiling_model_rs_PhaseTiming:
      properties:
        duration_nanos:
          minimum: 0
          type: integer
        name:
          type: string
      required:
        - name
        - duration_nanos
      type: object
    shared_common_src_lib_rs_CatalogId:
      format: uuid
      type: string
    shared_common_src_workflow_rs_DataWindow:
      properties:
        end_unix_millis:
          type: integer
        start_unix_millis:
          type: integer
        timezone:
          type: string
      required:
        - start_unix_millis
        - end_unix_millis
        - timezone
      type: object
    shared_common_src_workflow_rs_RerunOrigin:
      properties:
        run_id:
          $ref: '#/components/schemas/shared_common_src_lib_rs_WorkloadRunId'
        tasks:
          description: >-
            Tasks to execute. Other tasks must have confirmed successful
            outcomes.
          items:
            type: string
          type: array
      required:
        - run_id
        - tasks
      type: object
    shared_common_src_lib_rs_WorkerScope:
      oneOf:
        - const: Task
          type: string
        - const: Workload
          type: string
        - const: Deployment
          type: string
    shared_common_src_lib_rs_CommitId:
      format: uuid
      type: string
    kernel_sensors_src_lib_rs_WaitState:
      properties:
        checks:
          minimum: 0
          type: integer
        deadline_unix_millis:
          type: integer
        last_observation:
          anyOf:
            - type: string
            - type: 'null'
        next_check_unix_millis:
          type: integer
        satisfied:
          type: boolean
        started_at_unix_millis:
          type: integer
      required:
        - started_at_unix_millis
        - deadline_unix_millis
        - next_check_unix_millis
        - checks
        - last_observation
        - satisfied
      type: object
    shared_common_src_lib_rs_CommitReceipt:
      properties:
        boundary:
          $ref: '#/components/schemas/shared_common_src_lib_rs_WriteBoundary'
        commit:
          $ref: >-
            #/components/schemas/shared_common_src_lib_rs_DestinationCommitReceipt
        commit_id:
          $ref: '#/components/schemas/shared_common_src_lib_rs_CommitId'
        plan_id:
          $ref: '#/components/schemas/shared_common_src_lib_rs_ConnectorPlanId'
        target:
          $ref: '#/components/schemas/shared_common_src_lib_rs_WriteTarget'
      required:
        - plan_id
        - commit_id
        - target
        - boundary
        - commit
      type: object
    shared_common_src_lib_rs_WriteBoundary:
      oneOf:
        - const: Final
          type: string
        - properties:
            Checkpoint:
              $ref: '#/components/schemas/shared_common_src_lib_rs_Checkpoint'
          required:
            - Checkpoint
          type: object
    shared_common_src_lib_rs_DestinationCommitReceipt:
      oneOf:
        - properties:
            Table:
              $ref: '#/components/schemas/shared_common_src_lib_rs_TableCommitReceipt'
          required:
            - Table
          type: object
        - properties:
            Direct:
              properties:
                receipt:
                  $ref: '#/components/schemas/shared_common_src_lib_rs_DurablePayload'
                version:
                  anyOf:
                    - type: string
                    - type: 'null'
                  description: >-
                    None means the destination does not expose a committed
                    version.
              required:
                - receipt
                - version
              type: object
          required:
            - Direct
          type: object
    shared_common_src_lib_rs_ConnectorPlanId:
      format: uuid
      type: string
    shared_common_src_lib_rs_WriteTarget:
      oneOf:
        - properties:
            Table:
              $ref: '#/components/schemas/shared_common_src_lib_rs_TableWriteTarget'
          required:
            - Table
          type: object
        - properties:
            Direct:
              $ref: >-
                #/components/schemas/shared_common_src_lib_rs_DirectResourceReference
          required:
            - Direct
          type: object
    shared_common_src_lib_rs_Checkpoint:
      properties:
        id:
          $ref: '#/components/schemas/shared_common_src_lib_rs_CheckpointId'
        sequence:
          minimum: 1
          type: integer
      required:
        - id
        - sequence
      type: object
    shared_common_src_lib_rs_TableCommitReceipt:
      properties:
        commit_id:
          $ref: '#/components/schemas/shared_common_src_lib_rs_CommitId'
        committed_table:
          $ref: '#/components/schemas/shared_common_src_lib_rs_ResolvedTableReference'
        target:
          $ref: '#/components/schemas/shared_common_src_lib_rs_TableWriteTarget'
      required:
        - commit_id
        - target
        - committed_table
      type: object
    shared_common_src_lib_rs_DurablePayload:
      oneOf:
        - properties:
            Inline:
              $ref: '#/components/schemas/shared_common_src_lib_rs_EncodedPayload'
          required:
            - Inline
          type: object
        - properties:
            Stored:
              properties:
                codec:
                  type: string
                object:
                  $ref: '#/components/schemas/shared_common_src_lib_rs_ResultObject'
                version:
                  minimum: 1
                  type: integer
              required:
                - object
                - codec
                - version
              type: object
          required:
            - Stored
          type: object
    shared_common_src_lib_rs_TableWriteTarget:
      oneOf:
        - properties:
            Existing:
              $ref: >-
                #/components/schemas/shared_common_src_lib_rs_ResolvedTableReference
          required:
            - Existing
          type: object
        - properties:
            Staged:
              $ref: >-
                #/components/schemas/shared_common_src_lib_rs_StagedTableReference
          required:
            - Staged
          type: object
    shared_common_src_lib_rs_DirectResourceReference:
      properties:
        configuration_revision:
          type: string
        connector:
          type: string
        identity:
          type: string
        resource:
          type: string
        state:
          $ref: '#/components/schemas/shared_common_src_lib_rs_EncodedPayload'
        version:
          anyOf:
            - type: string
            - type: 'null'
          description: None is unversioned and does not promise repeatable reads.
      required:
        - connector
        - resource
        - identity
        - configuration_revision
        - version
        - state
      type: object
    shared_common_src_lib_rs_CheckpointId:
      format: uuid
      type: string
    shared_common_src_lib_rs_ResolvedTableReference:
      properties:
        catalog_revision:
          type: string
        catalog_state:
          $ref: '#/components/schemas/shared_common_src_lib_rs_EncodedPayload'
        data_version:
          $ref: '#/components/schemas/shared_common_src_lib_rs_TableDataVersion'
        metadata_revision:
          type: string
        table:
          $ref: '#/components/schemas/shared_common_src_lib_rs_TableReference'
        table_identity:
          type: string
      required:
        - table
        - catalog_revision
        - table_identity
        - metadata_revision
        - data_version
        - catalog_state
      type: object
    shared_common_src_lib_rs_EncodedPayload:
      properties:
        codec:
          type: string
        payload:
          items:
            minimum: 0
            type: integer
          type: array
        version:
          minimum: 1
          type: integer
      required:
        - codec
        - version
        - payload
      type: object
    shared_common_src_lib_rs_ResultObject:
      properties:
        bytes:
          minimum: 0
          type: integer
        key:
          type: string
        version:
          type: string
      required:
        - key
        - version
        - bytes
      type: object
    shared_common_src_lib_rs_StagedTableReference:
      properties:
        stage_id:
          $ref: '#/components/schemas/shared_common_src_lib_rs_TableStageId'
        table:
          $ref: '#/components/schemas/shared_common_src_lib_rs_ResolvedTableReference'
      required:
        - stage_id
        - table
      type: object
    shared_common_src_lib_rs_TableStageId:
      format: uuid
      type: string

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.